#include "testlib.h"
using namespace std;
string COLORS[256];
int next_index(const int i, const int n)
{
	return (i == (n - 1)) ? 0 : i + 1;
}
int previous_index(const int i, const int n)
{
	return (i ? i : n) - 1;
}
bool checkAns(InStream& in, const int n, string s, string const& t, int& k)
{
	k = in.readInt(-1, 10 * n, "k");
	if (k == -1)
		return false;
	for (int i = 0; i < k; ++i)
	{
		int p = in.readInt(1, n, format("p[%d]", i + 1)) - 1;
		string c = in.readToken("[RYB]{1}");
		char previous_color = s[previous_index(p, n)];
		char next_color = s[next_index(p, n)];
		in.ensuref(previous_color != next_color,
			"during the %d%s operation the %d%s candle was targeted, although it's neighbors are both %s",
			i + 1, englishEnding(i + 1).c_str(),
			p + 1, englishEnding(p + 1).c_str(),
			COLORS[previous_color].c_str()
		);
		s[p] = c.front();
	}
	for (int i = 0; i < n; ++i)
		in.ensuref(s[i] == t[i],
			"operations resulted in that %d%s candle's color is %s (expected %s)",
			i + 1, englishEnding(i + 1).c_str(),
			COLORS[s[i]].c_str(),
			COLORS[t[i]].c_str()
		);
	return true;
}
int main(int argc, char* argv[])
{
	COLORS['R'] = "red";
	COLORS['Y'] = "yellow";
	COLORS['B'] = "blue";
	registerTestlibCmd(argc, argv);
	int n = inf.readInt();
	int k = 0;
	string s = inf.readToken();
	string t = inf.readToken();
	bool juryAns = checkAns(ans, n, s, t, k);
	bool participantAns = checkAns(ouf, n, s, t, k);
	if (juryAns != participantAns)
	{
		if (juryAns)
			quitf(_wa, "jury has an answer but participant has not");
		else
			quitf(_fail, "participant has an answer but jury has not");
	}
	else
	{
		if (juryAns)
			quitf(_ok, "correct sequence of length %d", k);
		else
			quitf(_ok, "no answer");
	}
}