#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

int next_index(const int i, const int n)
{
	return (i == (n - 1)) ? 0 : i + 1;
}

int previous_index(const int i, const int n)
{
	return (i ? i : n) - 1;
}

void act(string& s, vector<pair<int, pair<char, char>>>& actions, const int index, const char c)
{
	actions.emplace_back(index, pair<char, char>(s[index], c));
	s[index] = c;
}

bool find_three_consecutive_different(const string& s, int& index)
{
	for (int i = 0; i < s.size(); ++i)
	{
		if (
			s[index] != s[previous_index(index, s.size())] &&
			s[index] != s[next_index(index, s.size())] &&
			s[next_index(index, s.size())] != s[previous_index(index, s.size())])
			return true;
		index = next_index(index, s.size());
	}
	return false;
}

void deal_with_three_consecutive_different(string& s, vector<pair<int, pair<char, char>>>& actions, int& index)
{
	if (s[index] != 'R')
		act(s, actions, index, 'R');
	else
	{
		int index1 = next_index(index, s.size());
		int index2 = next_index(index1, s.size());
		if (s[index2] != 'R')
			act(s, actions, index1, 'R');
		else
		{
			act(s, actions, index, s[index1]);
			act(s, actions, index1, 'R');
			index = index1;
		}
	}
}

bool find_two_consecutive_equal(const string& s, int& index)
{
	for (index = 0; index < s.size(); ++index)
		if (s[index] == s[next_index(index, s.size())])
			return true;
	return false;
}

bool find_end_of_equal_block(const string& s, int& index)
{
	for (int i = 0; i < s.size(); ++i)
	{
		int new_index = next_index(index, s.size());
		if (s[new_index] != s[index])
			return true;
		else
			index = new_index;
	}
	return false;
}

bool find_begin_of_equal_block(const string& s, int& index)
{
	for (int i = 0; i < s.size(); ++i)
	{
		int new_index = previous_index(index, s.size());
		if (s[new_index] != s[index])
			return true;
		else
			index = new_index;
	}
	return false;
}

int count_symbols(const string& s, const char c)
{
	int ans = 0;
	for (int i = 0; i < s.size(); ++i)
		if (s[i] == c)
			++ans;
	return ans;
}

int countR(const string& s)
{
	return count_symbols(s, 'R');
}

char different_char(const char a, const char b)
{
	if (a != 'R' && b != 'R')
		return 'R';
	if (a != 'Y' && b != 'Y')
		return 'Y';
	return 'B';
}

void jump_right(string& s, vector<pair<int, pair<char, char>>>& actions, int& right_index, int& super_right_index)
{
	int super_super_right_index = next_index(super_right_index, s.size());
	if (s[super_right_index] != 'R')
	{
		if (s[super_super_right_index] != 'R')
			act(s, actions, super_right_index, 'R');
		else
		{
			int super_super_super_right_index = next_index(super_super_right_index, s.size());
			char black = s[super_super_super_right_index];
			char white = different_char('R', black);
			char life = s[super_right_index];
			char death = 'Y' + 'B' - life;
			act(s, actions, right_index, life);
			act(s, actions, super_right_index, white);
			act(s, actions, super_super_right_index, death);
			act(s, actions, right_index, 'R');
			act(s, actions, super_right_index, 'R');
		}
	}
	right_index = super_right_index;
	super_right_index = super_super_right_index;
}

void jump_left(string& s, vector<pair<int, pair<char, char>>>& actions, int& left_index, int& super_left_index)
{
	int super_super_left_index = previous_index(super_left_index, s.size());
	if (s[super_left_index] != 'R')
	{
		if (s[super_super_left_index] != 'R')
			act(s, actions, super_left_index, 'R');
		else
		{
			int super_super_super_left_index = previous_index(super_super_left_index, s.size());
			char black = s[super_super_super_left_index];
			char white = different_char('R', black);
			char life = s[super_left_index];
			char death = 'Y' + 'B' - life;
			act(s, actions, left_index, life);
			act(s, actions, super_left_index, white);
			act(s, actions, super_super_left_index, death);
			act(s, actions, left_index, 'R');
			act(s, actions, super_left_index, 'R');
		}
	}
	left_index = super_left_index;
	super_left_index = super_super_left_index;
}

// choose some index
// make s[index] = 'Y' || s[index] = 'B'
// s[the rest] = 'R'
bool softly_simplify(string& s, vector<pair<int, pair<char, char>>>& actions, int& index)
{
	index = 0;
	if (find_three_consecutive_different(s, index))
		deal_with_three_consecutive_different(s, actions, index);
	else if (find_two_consecutive_equal(s, index))
	{
		if (!find_end_of_equal_block(s, index))
			return false;
		if (s[index] != 'R')
		{
			act(s, actions, index, 'R');
			int new_index = next_index(index, s.size());
			if (s[new_index] != 'R')
				deal_with_three_consecutive_different(s, actions, index);
		}
	}
	else
		return false;
	int left_index = index;
	if (find_begin_of_equal_block(s, left_index) == false)
		return false;
	int right_index = index;
	find_end_of_equal_block(s, right_index);
	int super_left_index = previous_index(left_index, s.size());
	int super_right_index = next_index(right_index, s.size());
	while (super_left_index != super_right_index)
	{
		if (super_left_index < super_right_index)
			jump_right(s, actions, right_index, super_right_index);
		else if (super_left_index + super_right_index > s.size())
			jump_right(s, actions, right_index, super_right_index);
		else
			jump_left(s, actions, left_index, super_left_index);
	}
	index = super_left_index;
}

void shift_left_once(string& s, vector<pair<int, pair<char, char>>>& actions, int& index)
{
	int new_index = previous_index(index, s.size());
	act(s, actions, new_index, 'Y');
	act(s, actions, index, 'R');
	index = new_index;
}

void shift_left(string& s, vector<pair<int, pair<char, char>>>& actions, int index)
{
	while (index)
		shift_left_once(s, actions, index);
}

void shift_right_once(string& s, vector<pair<int, pair<char, char>>>& actions, int& index)
{
	int new_index = next_index(index, s.size());
	act(s, actions, new_index, 'Y');
	act(s, actions, index, 'R');
	index = new_index;
}

void shift_right(string& s, vector<pair<int, pair<char, char>>>& actions, int index)
{
	while (index)
		shift_right_once(s, actions, index);
}

// make s[0] = 'Y'
// s[the rest] = 'R'
bool simplify(string& s, vector<pair<int, pair<char, char>>>& actions)
{
	int index = 0;
	if (!softly_simplify(s, actions, index))
		return false;
	if (s[0] == 'B')
	{
		index = 1;
		act(s, actions, index, 'B');
	}
	if (index * 2 < s.size())
		shift_left(s, actions, index);
	else
		shift_right(s, actions, index);
	return true;
}
int main()
{
	ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#ifdef ONPC
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int n;
	cin >> n;
	string s, t;
	cin >> s >> t;
	vector<pair<int, pair<char, char>>> actions_s, actions_t;
	if (simplify(s, actions_s) && simplify(t, actions_t))
	{
		reverse(actions_t.begin(), actions_t.end());
		cout << actions_s.size() + actions_t.size() << '\n';
		for (auto a : actions_s)
			cout << a.first + 1 << ' ' << a.second.second << '\n';
		for (auto a : actions_t)
			cout << a.first + 1 << ' ' << a.second.first << '\n';
	}
	else if (s == t)
		cout << "0\n";
	else
		cout << "-1\n";
	return 0;
}