// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

#include "ext/pb_ds/assoc_container.hpp"

using namespace std;
using namespace __gnu_pbds;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;
int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }

template <typename T> using ordered_set = tree <T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

void solve() {
	int n;
	cin >> n;
	string s, t;
	cin >> s >> t;
	vector<pair<int, char>> ans;
	ordered_set<int> flip_positions, good_flip_positions;

	auto can_flip = [&](int pos) {
		int prev = (pos - 1 + n) % n, next = (pos + 1) % n;
		return s[prev] != s[next];
	};

	auto add_flip_pos = [&](int pos) {
		if (can_flip(pos)) {
			flip_positions.insert(pos);
			if (s[pos] != t[pos]) {
				good_flip_positions.insert(pos);
			}
		}
	};

	auto rem_flip_pos = [&](int pos) {
		if (can_flip(pos)) {
			flip_positions.erase(pos);
			if (s[pos] != t[pos]) {
				good_flip_positions.erase(pos);
			}
		}
	};

	for (int i = 0; i < n; ++i) {
		add_flip_pos(i);
	}

	auto do_flip = [&](int pos, char c) {
		int prev = (pos - 1 + n) % n;
		int next = (pos + 1) % n;
		rem_flip_pos(prev);
		rem_flip_pos(pos);
		rem_flip_pos(next);
		s[pos] = c;
		add_flip_pos(prev);
		add_flip_pos(pos);
		add_flip_pos(next);
		ans.push_back({pos, c});
	};

	while (s != t && szof(ans) < n * 10) {
		if (szof(good_flip_positions)) {
			auto it = good_flip_positions.find_by_order(rnd(0, szof(good_flip_positions) - 1));
			int pos = *it;
			do_flip(pos, t[pos]);
		} else {
			if (!szof(flip_positions)) {
				break;
			}
			auto it = flip_positions.find_by_order(rnd(0, szof(flip_positions) - 1));
			int pos = *it;
			do_flip(pos, "RYB"[rnd(0, 2)]);
		}
	}
	if (s != t) {
		cout << "-1\n";
		return;
	}
	cout << szof(ans) << "\n";
	for (auto p : ans) {
		cout << p.ff + 1 << " " << p.ss << "\n";
	}
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}
	
#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}
