// Dmitry _kun_ Sayutin (2019)

#include <bits/stdc++.h>

using std::cin;
using std::cout;
using std::cerr;

using std::vector;
using std::map;
using std::array;
using std::set;
using std::string;
using std::queue;

using std::pair;
using std::make_pair;

using std::tuple;
using std::make_tuple;
using std::get;

using std::min;
using std::abs;
using std::max;
using std::swap;

using std::unique;
using std::sort;
using std::generate;
using std::reverse;
using std::min_element;
using std::max_element;

#ifdef LOCAL
#define LASSERT(X) assert(X)
#else
#define LASSERT(X) {}
#endif

template <typename T>
T input() {
    T res;
    cin >> res;
    LASSERT(cin);
    return res;
}

template <typename IT>
void input_seq(IT b, IT e) {
    std::generate(b, e, input<typename std::remove_reference<decltype(*b)>::type>);
}

#define SZ(vec)         int((vec).size())
#define ALL(data)       data.begin(),data.end()
#define RALL(data)      data.rbegin(),data.rend()
#define TYPEMAX(type)   std::numeric_limits<type>::max()
#define TYPEMIN(type)   std::numeric_limits<type>::min()

const char* rgb = "RYB";

int index(char c) {
    int p = 0;
    while (rgb[p] != c)
        ++p;

    return p;
}

int main() {
    std::iostream::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    // code here
    int n = input<int>();
    vector<int> s(n, -1), t(n, -1);

    for (int i = 0; i < n; ++i)
        s[i] = index(input<char>());
    for (int i = 0; i < n; ++i)
        t[i] = index(input<char>());

    if (s == t) {
        cout << 0 << "\n";
        return 0;
    }

    auto convert = [&](vector<int>& arr) {
        vector<int> target(n);
        for (int i = 0; i < n; ++i)
            target[i] = i % 3;

        int pos = 0;
        
        while (pos < n and arr[(pos + n - 1) % n] == arr[(pos + 1) % n])
            ++pos;

        if (pos == n) {
            cout << -1 << "\n";
            exit(0);
        }

        vector<tuple<int, int, int>> result;

        auto make_change = [&](int i, int to) {
            if (arr[i] != to)
                result.emplace_back(i, arr[i], to);
            arr[i] = to;
        };

        std::function<void(int, int)> change_rec = [&](int what, int to) {
            if (arr[what] == to)
                return;

            if (arr[(what + n - 1) % n] != arr[(what + 1) % n]) {
                make_change(what, to);
            } else {
                int orig_color = arr[(what + n - 1) % n];
                int other_color = (orig_color + 2) % 3;

                change_rec((what + n - 1) % n, other_color);
                make_change(what, to);
                change_rec((what + n - 1) % n, orig_color);
            }
        };
        
        make_change(pos, target[pos]);
        
        for (int ind = (pos + 1) % n; ind != pos; ind = (ind + 1) % n) {
            change_rec(ind, target[ind]);
        }

        return result;
    };
    
    auto r1 = convert(s);
    auto r2 = convert(t);

    reverse(ALL(r2));
    cout << SZ(r1) + SZ(r2) << "\n";
    for (auto elem: r1)
        cout << 1 + get<0>(elem) << " " << rgb[get<2>(elem)] << "\n";
    for (auto elem: r2)
        cout << 1 + get<0>(elem) << " " << rgb[get<1>(elem)] << "\n";
        
    

    return 0;
}
