// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;
int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }

vector<int> add(vector<int> const& a, int val) {
	vector<int> c;
	int carry = val;
	for (int num : a) {
		carry += num;
		c.push_back(carry % 10);
		carry /= 10;
	}
	while (carry) {
		c.push_back(carry % 10);
		carry /= 10;
	}
	return c;
}

bool leq(vector<int> const& a, vector<int> const& b) {
	if (szof(a) != szof(b)) {
		return szof(a) < szof(b);
	}
	for (int i = szof(a) - 1; i >= 0; --i) {
		if (a[i] != b[i]) {
			return a[i] < b[i];
		}
	}
	return true;
}

void solve() {
	string sa, sb;
	cin >> sa >> sb;
	vector<int> a, b;
	for (char c : sa) {
		a.push_back(c - '0');
	}
	for (char c : sb) {
		b.push_back(c - '0');
	}
	reverse(a.begin(), a.end());
	reverse(b.begin(), b.end());
	int res = 1;
	while (leq(a, b)) {
		int cur = 0;
		int p10 = 1;
		for (int num : a) {
			cur = (cur + p10 * num) % 9;
			p10 = p10 * 10 % 9;
		}
		res = res * cur % 9;
		a = add(a, 1);
	}

	if (res == 0) {
		res = 9;
	}
	cout << res << "\n";
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}
	
#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}
