// Dmitry _kun_ Sayutin (2019)

#include <bits/stdc++.h>
#include "testlib.h"

using std::cin;
using std::cout;
using std::cerr;

using std::vector;
using std::map;
using std::array;
using std::set;
using std::string;
using std::queue;

using std::pair;
using std::make_pair;

using std::tuple;
using std::make_tuple;
using std::get;

using std::min;
using std::abs;
using std::max;
using std::swap;

using std::unique;
using std::sort;
using std::generate;
using std::reverse;
using std::min_element;
using std::max_element;

#ifdef LOCAL
#define LASSERT(X) assert(X)
#else
#define LASSERT(X) {}
#endif

template <typename T>
T input() {
    T res;
    cin >> res;
    LASSERT(cin);
    return res;
}

template <typename IT>
void input_seq(IT b, IT e) {
    std::generate(b, e, input<typename std::remove_reference<decltype(*b)>::type>);
}

#define SZ(vec)         int((vec).size())
#define ALL(data)       data.begin(),data.end()
#define RALL(data)      data.rbegin(),data.rend()
#define TYPEMAX(type)   std::numeric_limits<type>::max()
#define TYPEMIN(type)   std::numeric_limits<type>::min()

int main(int argc, char** argv) {
    std::iostream::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    // code here
    registerGen(argc, argv, 1);
    
    int n = atoi(argv[1]);
    
    const int DISJ = 0;
    const int SIMPL = 1;
    const int ALLEQ = 2;
    const int REDUCE0 = 3;

    int mode;
    if (argv[2] == string("disj"))
        mode = DISJ;
    else if (argv[2] == string("simpl"))
        mode = SIMPL;
    else if (argv[2] == string("alleq"))
        mode = ALLEQ;
    else
        mode = REDUCE0;
    
    cout << n << "\n";

    for (int i = 0; i < n; ++i) {
        if (mode == DISJ) {
            string next = "0123456789";
            shuffle(ALL(next));
            next.resize(6);
            cout << next << "\n";
        } else if (mode == SIMPL) {
            string next = "000000";
            std::generate(ALL(next), []() {return rnd.next('0', '9');});
            cout << next << "\n";
        } else if (mode == ALLEQ) {
            string next = "000000";
            std::fill(ALL(next), rnd.next('0', '9'));
            cout << next << "\n";
        } else {
            string next = "000000";
            std::generate(ALL(next), []() {return "0112233445566778899"[rnd.next(0, 18)];});
            cout << next << "\n";
        }
    }

    return 0;
}
