#include "testlib.h"
#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

struct Fv {
    int sz;
    vector<int> fv;

    Fv(int sz_) : sz(sz_), fv(sz) {}

    int pref(int i) {
        int s = 0;
        while (i >= 0) {
            s += fv[i];
            i = (i & (i + 1)) - 1;
        }
        return s;
    }

    void add(int i, int v) {
        while (i < fv.size()) {
            fv[i] += v;
            i = i | (i + 1);
        }
    }
};

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);

    int n = atoi(argv[1]);
    int q = atoi(argv[2]);
    int C = atoi(argv[3]);

    cout << n << " " << q << endl;

    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        a[i] = rnd.next(1, C);
        if (i > 0) {
            cout << " ";
        }
        cout << a[i];
    }
    cout << endl;

    Fv f(n + q);

    int cnt = n;
    for (int i = 0; i < q; ++i) {
        int t = rnd.next(1, 3);
        while (t == 2 && cnt == 0) {
            t = rnd.next(1, 3);
        }

        if (t == 1) {
            int v = rnd.next(1, C);
            a.push_back(v);
            ++cnt;
            cout << t << " " << v << "\n";
        } else if (t == 2) {
            int num = rnd.next(1, cnt);
            int L = -1;
            int R = n + q - 1;
            while (R - L > 1) {
                int M = (L + R) / 2;
                if (M + 1 - f.pref(M) >= num) {
                    R = M;
                } else {
                    L = M;
                }
            }
            int v = R + 1;

            --cnt;
            f.add(R, 1);

            cout << t << " " << v << "\n";
        } else {
            int v = rnd.next(1, C);
            cout << t << " " << v << "\n";
        }
    }

    return 0;
}