#include <cmath>
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <list>
#include <time.h>
#include <math.h>
#include <random>
#include <deque>
#include <queue>
#include <cassert>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <bitset>
#include <sstream>
#include <chrono>
#include <cstring>

using namespace std;

typedef long long ll;

mt19937 rnd(228);

double start;

ll smart(vector <int> a, vector <pair <int, int> > segs) {
  int n = (int) a.size();
  vector <ll> cnt(a.size());
  for (auto c : segs) {
    for (int i = c.first; i <= c.second; i++) {
      cnt[i]++;
    }
  }
  sort(a.begin(), a.end());
  ll value = 0;
  vector <int> b(n);
  vector <bool> vis(n);
  auto was = segs;
  while (!a.empty()) {
    int x = 0;
    for (int i = 0; i < n; i++) if (!vis[i]) x = i;
    for (int i = 0; i < n; i++) {
      if (cnt[i] > cnt[x] && !vis[i]) {
        x = i;
      }
    }
    vis[x] = true;
    value += cnt[x] * a.back();
    b[x] = a.back();
    a.pop_back();
    vector <pair <int, int> > now;
    for (auto c : segs) {
      if (c.second < x || c.first > x) {
        now.push_back(c);
      } else {
        for (int i = c.first; i <= c.second; i++) {
          cnt[i]--;
        }
      }
    }
    segs = now;
  }
  segs = was;
  auto cost = [&] (vector <int> a) {
    ll sum = 0;
    for (auto c : segs) {
      int mx = 0;
      for (int i = c.first; i <= c.second; i++) {
        mx = max(mx, a[i]);
      }
      sum += mx;
    }
    return sum;
  };
  bool ch = true;
  ll me = cost(b);
  while (ch) {
    ch = false;
    for (int i = 0; i < n; i++) {
      for (int j = i + 1; j < n; j++) {
        swap(b[i], b[j]);
        ll go = cost(b);
        if (go > me) {
          ch = true;
          me = go;
        } else if (go < me) {
          swap(b[i], b[j]);
        }
      }
    }
  }
  start = clock();
  for (int it = 0; it < 10; it++) {
    auto arr = b;
    shuffle(arr.begin(), arr.end(), rnd);
    bool ch = true;
    ll me = cost(arr);
    while (ch) {
      ch = false;
      for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
          swap(arr[i], arr[j]);
          ll go = cost(arr);
          if (go > me) {
            ch = true;
            me = go;
          } else if (go < me) {
            swap(arr[i], arr[j]);
          }
        }
      }
    }
    if (cost(arr) > cost(b)) {
      b = arr;
    }
  }
  return cost(b);
}

const int N = 50;
const int lim = 30;

vector <int> ord;

map <vector <int>, int> dp;

vector <int> ok[lim + 1];
vector <vector <int> > orz;

int ind = 0;

void dfs(int sum, int last) {
  orz.push_back(ord);
  ok[sum].push_back(ind);
  dp[ord] = ind++;
  for (int i = last; sum + i <= lim; i++) {
    ord.push_back(i);
    dfs(sum + i, i);
    ord.pop_back();
  }
}

map <pair <int, int>, int> prec;
set <int> values[N][N];


ll retard(vector <int> a, vector <pair <int, int> > e) {
  int n = (int) a.size();
  for (int i = 0; i <= n; i++) {
    for (int j = 0; j <= n; j++) {
      values[i][j].clear();
    }
  }
  for (int i = 0; i <= n; i++) {
    values[i][i].insert(0);
  }
  for (int len = 1; len <= n; len++) {
    for (int i = 0; i + len - 1 < n; i++) {
      int j = i + len;
      for (int k = i; k < j; k++) {
        int me = 0;
        for (auto c : e) {
          if (i <= c.first && c.first <= k && k <= c.second && c.second < j) {
            me++;
          }
        }
        int value = dp[{me}];
        for (int x : values[i][k]) {
          for (int y : values[k + 1][j]) {
            int ret = prec[{prec[{x, y}], value}];
            values[i][j].insert(ret);
          }
        }
      }
    }
  }
  sort(a.rbegin(), a.rend());
  ll ans = 0;
  for (int x : values[0][n]) {
    auto ret = orz[x];
    reverse(ret.begin(), ret.end());
    ll value = 0;
    for (int i = 0; i < (int) ret.size(); i++) {
      value += ret[i] * a[i];
    }
    ans = max(ans, value);
  }
  return ans;
}

int inf = 1e9;

int main() {
#ifdef iq
  freopen("a.in", "r", stdin);
#endif
  ios::sync_with_stdio(0);
  cin.tie(0);
  dfs(0, 1);
  /*
  int lim = 30;
  for (int i = 0; i <= lim; i++) {
    for (int j = 0; i + j <= lim; j++) {
      for (int a : ok[i]) {
        for (int b : ok[j]) {
          if (a > b) continue;
          auto c = orz[a];
          for (int x : orz[b]) c.push_back(x);
          sort(c.begin(), c.end());
          prec[{a, b}] = prec[{b, a}] = dp[c];
        }
      }
    }
  }
  int ptr = 0;
  while (true) {
    int n = rnd() % 30 + 1;
    int c = rnd() % inf + 1;
    vector <int> a;
    for (int i = 0; i < n; i++) {
      a.push_back(rnd() % c);
    }
    int q = rnd() % 30 + 1;
    vector <pair <int, int> > seg;
    for (int i = 0; i < q; i++) {
      int l = rnd() % n, r = rnd() % n;
      if (l > r) swap(l, r);
      seg.push_back({l, r});
    }
    if (retard(a, seg) != smart(a, seg)) {
      cout << n << '\n';
      for (int x : a) {
        cout << x << ' ';
      }
      cout << '\n';
      cout << q << '\n';
      for (auto c : seg) {
        cout << c.first + 1 << ' ' << c.second + 1 << '\n';
      }
      assert(0);
    } else {
      cout << "OK" << ' ' << ptr << endl;
      ptr++;
    }
  }
  */
  int n, m;
  cin >> n >> m;
  /*
  vector <int> a(n);
  for (int i = 0; i < n; i++) {
    cin >> a[i];
  }
  */
  int q;
  cin >> q;
  vector <pair <int, int> > e;
  for (int i = 0; i < q; i++) {
    int l, r;
    cin >> l >> r;
    l--, r--;
    e.push_back({l, r});
  }
  for (int i = 0; i < m; i++) {
    vector <int> a(n);
    for (int &x : a) cin >> x;
    cout << smart(a, e) << '\n';
  }
}

