// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;
int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }


void solve() {
	int n, m;
	cin >> n >> m;
	int q;
	cin >> q;
	vector<pii> segs;
	for (int i = 0; i < q; ++i) {
		int l, r;
		cin >> l >> r;
		--l; --r;
		segs.push_back({l, r});
	}

	vector<vector<vector<vector<int>>>> dp(n, vector<vector<vector<int>>>(n));
	vector<int> tmp;

	for (int len = 1; len <= n; ++len) {
		for (int i = 0; i + len <= n; ++i) {
			int j = i + len - 1;
			for (int k = i; k <= j; ++k) {
				vector<vector<int>> lpart;
				if (i < k) {
					lpart = dp[i][k - 1];
				} else {
					lpart = {{}};
				}
				vector<vector<int>> rpart;
				if (k < j) {
					rpart = dp[k + 1][j];
				} else {
					rpart = {{}};
				}

				int cnt = 0;
				for (auto [l, r] : segs) {
					if (i <= l && l <= k && k <= r && r <= j) {
						++cnt;
					}
				}

				for (auto& arrl : lpart) {
					for (auto& arrr : rpart) {
						if ((szof(arrl) && arrl.back() > cnt) || (szof(arrr) && arrr.back() > cnt)) {
							continue;
						}
						tmp.resize(j - i);
						merge(arrl.begin(), arrl.end(), arrr.begin(), arrr.end(), tmp.begin());
						tmp.push_back(cnt);
						dp[i][j].push_back(tmp);
					}
				}
			}
			sort(dp[i][j].begin(), dp[i][j].end());
			dp[i][j].erase(unique(dp[i][j].begin(), dp[i][j].end()), dp[i][j].end());
			// cerr << "dp " << i << " " << j << endl;
			// for (auto& var : dp[i][j]) {
			// 	for (int num : var) {
			// 		cerr << num << " ";
			// 	}
			// 	cerr << endl;
			// }
		}
	}

	for (int i = 0; i < m; ++i) {
		vector<int> arr;
		for (int j = 0; j < n; ++j) {
			int num;
			cin >> num;
			arr.push_back(num);
		}
		sort(arr.begin(), arr.end());
		ll ans = 0;
		for (auto& var : dp[0][n - 1]) {
			ll cur = 0;
			for (int j = 0; j < n; ++j) {
				cur += (ll) var[j] * arr[j];
			}
			ans = max(ans, cur);
		}
		cout << ans << "\n";
	}
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}
	
#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}
