#include <bits/stdc++.h>
#include "testlib.h"
using namespace std;

int cur_test = -1;
const int MAXN = 100000;

void write_test(string test) 
{
    startTest(cur_test++);
    cerr << cur_test << endl;
    cout << test << endl;
}

string chars = "</>";

void gen_rand(int n)
{
    string s = "";
    for (int i = 0; i < n; i++)
        s += chars[rnd.next(chars.size())];
    write_test(s);
}

void gen_correct(int n)
{
    int cnt = rnd.next(1, n / 7);
    string res = "";
    for (int i = 0; i < cnt; i++)
    {
        res += "<</>>";
        char c = char(rnd.next('a', 'z'));
        res += c;
        res += c;
    }
    while (int(res.size()) + 2 < n)
    {
        char c = char(rnd.next('a', 'z'));
        res += c;
        res += c;
    }
    shuffle(res.begin(), res.end());
    write_test(res);
}

void gen_correct_max_tags(int n)
{
    int cnt = n / 7;
    string res = "";
    for (int i = 0; i < cnt; i++)
    {
        res += "<</>>";
        char c = char(rnd.next('a', 'z'));
        res += c;
        res += c;
    }
    while (int(res.size()) + 2 < n)
    {
        char c = char(rnd.next('a', 'z'));
        res += c;
        res += c;
    }
    shuffle(res.begin(), res.end());
    write_test(res);
}

void gen_incorrect(int n)
{
    int cnt = rnd.next(1, n / 7);
    string res = "";
    for (int i = 0; i < cnt; i++)
    {
        res += "<</>>";
        char c = char(rnd.next('a', 'z'));
        res += c;
        res += c;
    }
    while (int(res.size()) + 2 < n)
    {
        char c = char(rnd.next('a', 'z'));
        res += c;
        res += c;
    }
    res[rnd.next(res.size())] = chars[rnd.next(chars.size())];
    shuffle(res.begin(), res.end());
    write_test(res);
}

void gen_incorrect2(int n)
{
    int cnt = rnd.next(1, n / 7);
    string res = "";
    for (int i = 0; i < cnt - 1; i++)
    {
        res += "<</>>";
        char c = char(rnd.next('a', 'z'));
        res += c;
        res += c;
    }
    res += "<<>>";
    char c = char(rnd.next('a', 'z'));
    res += c;
    res += c;
    while (int(res.size()) + 2 < n)
    {
        char c = char(rnd.next('a', 'z'));
        res += c;
        res += c;
    }
    shuffle(res.begin(), res.end());
    write_test(res);
}

void gen_incorrect3(int n)
{
    int cnt = rnd.next(1, n / 7);
    string res = "";
    for (int i = 0; i < cnt - 1; i++)
    {
        res += "<</>>";
        char c = char(rnd.next('a', 'z'));
        res += c;
        res += c;
    }
    res += "<</>";
    char c = char(rnd.next('a', 'z'));
    res += c;
    res += c;
    while (int(res.size()) + 2 < n)
    {
        char c = char(rnd.next('a', 'z'));
        res += c;
        res += c;
    }
    shuffle(res.begin(), res.end());
    write_test(res);
}

void gen_incorrect4(int n)
{
    int cnt = rnd.next(1, n / 7);
    string res = "";
    for (int i = 0; i < cnt - 1; i++)
    {
        res += "<</>>";
        char c = char(rnd.next('a', 'z'));
        res += c;
        res += c;
    }
    res += "</>>";
    char c = char(rnd.next('a', 'z'));
    res += c;
    res += c;
    while (int(res.size()) + 2 < n)
    {
        char c = char(rnd.next('a', 'z'));
        res += c;
        res += c;
    }
    shuffle(res.begin(), res.end());
    write_test(res);
}

void gen_incorrect5(int n)
{
    int cnt = n / 7;
    string res = "";
    for (int i = 0; i < cnt; i++)
    {
        res += "<</>>";
    }
    int cnt_ = rnd.next(cnt/2, cnt);
    for (int i = cnt / 2; i < cnt_; i++)
    {
        char c = char(rnd.next('a', 'z'));
        res += c;
        res += c;
    }
    shuffle(res.begin(), res.end());
    write_test(res);
}

void gen_incorrect6(int n)
{
    int cnt = rnd.next(1, n / 7);
    string res = "";
    for (int i = 0; i < cnt - 1; i++)
    {
        res += "<</>>";
        char c = char(rnd.next('a', 'z'));
        res += c;
        res += c;
    }
    res += "<</>>>";
    char c = char(rnd.next('a', 'z'));
    res += c;
    res += c;
    while (int(res.size()) + 2 < n)
    {
        char c = char(rnd.next('a', 'z'));
        res += c;
        res += c;
    }
    shuffle(res.begin(), res.end());
    write_test(res);
}

void gen_incorrect7(int n)
{
    int cnt = rnd.next(1, n / 7);
    string res = "";
    for (int i = 0; i < cnt - 1; i++)
    {
        res += "<</>>";
        char c = char(rnd.next('a', 'z'));
        res += c;
        res += c;
    }
    res += "<<</>>";
    char c = char(rnd.next('a', 'z'));
    res += c;
    res += c;
    while (int(res.size()) + 2 < n)
    {
        char c = char(rnd.next('a', 'z'));
        res += c;
        res += c;
    }
    shuffle(res.begin(), res.end());
    write_test(res);
}


int main(int argc, char * argv[]) 
{
    registerGen(argc, argv, 1);
    cur_test = atoi(argv[1]);

    for (char c = 'a'; c <= 'z'; c++)
        chars += c;
    
    gen_rand(5);
    gen_correct(10);
    gen_correct_max_tags(35);
    gen_incorrect(15);
    gen_incorrect2(16);
    gen_incorrect3(20);
    gen_incorrect4(21);
    gen_incorrect5(19);
    gen_incorrect6(25);
    gen_incorrect7(12);
    
    for (int n = 100; n <= MAXN; n *= 10)
    {
        gen_rand(rnd.next(n/2, n));
        gen_correct(rnd.next(n/2, n));
        gen_correct_max_tags(rnd.next(n/2, n));
        gen_incorrect(rnd.next(n/2, n));
        gen_incorrect2(rnd.next(n/2, n));
        gen_incorrect3(rnd.next(n/2, n));
        gen_incorrect4(rnd.next(n/2, n));
        gen_incorrect5(rnd.next(n/2, n));
        gen_incorrect6(rnd.next(n/2, n));
        gen_incorrect7(rnd.next(n/2, n));
    }
    gen_rand(MAXN);
    gen_correct(MAXN);
    gen_correct_max_tags(MAXN);
    gen_incorrect(MAXN);
    gen_incorrect2(MAXN);
    gen_incorrect3(MAXN);
    gen_incorrect4(MAXN);
    gen_incorrect5(MAXN);
    gen_incorrect6(MAXN);
    gen_incorrect7(MAXN);
    
    return 0;
}